﻿using System.Runtime.Serialization;
using DecisionsFramework.Data.ORMapper;
using DecisionsFramework.Design.ConfigurationStorage.Attributes;
using DecisionsFramework.Design.Properties;
using DecisionsFramework.ServiceLayer;
using DecisionsFramework.ServiceLayer.Actions;
using DecisionsFramework.ServiceLayer.Utilities;

namespace BasicORMExample
{
    [ORMEntity("MyCustomer")]
    public class MyCustomer: AbstractEntity
    {
        [ORMPrimaryKeyField] 
        [PropertyHidden]
        [DataMember]
        public string Id { get; set; }
        
        [ORMField("first_name")]
        [DataMember]
        [WritableValue]
        public string FirstName { get; set; }
        
        [ORMField("last_name")]
        [DataMember]
        [WritableValue]
        public string LastName { get; set; }
        
        [PropertyHidden]
        [DataMember]
        public override string EntityName
        {
            get
            {
                return FirstName;
            }
            set
            {
                FirstName = value;
            }
        }
        
        [PropertyHidden]
        [DataMember]
        public override string EntityDescription
        {
            get
            {
                return FirstName;
            }
            set
            {
                FirstName = value;
            }
        }
        
        public override BaseActionType[] GetActions(AbstractUserContext userContext, EntityActionType[] types)
        {
            return new BaseActionType[0];
        }
    }
}